#include <htc.h>

/* Program device configuration word
 * Oscillator = Internal RC No Clock
 * Watchdog Timer = Off
 * Power Up Timer = Off
 * Master Clear Enable = Off
 * Code Protect = Off
 * Data EE Read Protect = Off
 * Brown Out Detect = BOD and SBOREN disabled
 * Internal External Switch Over Mode = Disabled
 * Monitor Clock Fail-safe = Disabled
 */
__CONFIG(INTIO&WDTDIS&PWRTDIS&MCLRDIS&UNPROTECT&UNPROTECT&BORDIS&IESODIS&FCMDIS);

/*
 * Sets up comparator to translate CMOS 1.8V levels to 5V.
 */
void comparator_setup(void) {
  // Comparator 1 input (RA1/C12IN0-) setup
  ANS1=1; // enable analog input
  TRISA1=1; // enable input

  // Comparator 1 output (RA2) setup
  TRISA2=0; // enable output

  // Comparator 1 setup
  C1ON=1; // enable comparator 1
  C1OE=1; // output to RA2
  C1POL=1; // C1OUT=1 if high
  C1CH0=0; // C12IN0- selected as input
  C1CH1=0;
  // Enable voltage reference from CVREF - comparator voltage reference that
  // is by default 0.6V
  C1R=1;
}

void init(void) {
  // Make all pins digital
  ANSEL=0;
  ANSELH=0;

  // Set comparator
  comparator_setup();
}
